VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cSizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------
' 1999 Joe LeVasseur <lvasseur@tiac.net>
' Put together from several people's ideas
' and code.
'----------------------------------------------------
' USAGE:
'Private m_cSizer As New cSizer
'Private Sub Form_Resize()
'  If Me.WindowState <> vbMinimized Then m_cSizer.Resize Me, True
'End Sub
'------------------------------------------
'Private Const DEBUGMODE As Boolean = False
'------------------------------------------
Private Type ControlProperties
    Left    As Long
    Top     As Long
    Width   As Long
    Height  As Long
    FntSize As Single
End Type
Private tCtlProp() As ControlProperties
'---------

Private m_bInitDone         As Boolean
Private m_iControlsCount    As Long
Private m_lFormHeight       As Long
Private m_lFormWidth        As Long

Public Sub Resize(ByRef frm As Form, Optional DoFonts As Boolean = False)
    Dim i                       As Integer
    Dim dProportionateHeight    As Double
    Dim dProportionateWidth     As Double
    '----------------------------------------

    On Error GoTo errResize
  
    If Not m_bInitDone Then
        Call StoreOriginalSizes(frm)
        Exit Sub
    End If
    dProportionateHeight = frm.ScaleHeight / m_lFormHeight
    dProportionateWidth = frm.ScaleWidth / m_lFormWidth
    For i = 0 To m_iControlsCount - 1
        ' Seems to work better here...(Before resize.)
        'If DoFonts = True Then
        If DoFonts = True Then
            frm.Controls(i).Font.Size = tCtlProp(i).FntSize * dProportionateHeight
        End If
        If TypeOf frm.Controls(i) Is Timer Then
            ' Nothing to do ...
        ElseIf (TypeOf frm.Controls(i) Is ComboBox) Or _
            (TypeOf frm.Controls(i) Is DriveListBox) Then
            ' Can't set height
            frm.Controls(i).Move _
                tCtlProp(i).Left * dProportionateWidth, _
                tCtlProp(i).Top * dProportionateHeight, _
                tCtlProp(i).Width * dProportionateWidth
        Else
            frm.Controls(i).Move _
            tCtlProp(i).Left * dProportionateWidth, _
            tCtlProp(i).Top * dProportionateHeight, _
            tCtlProp(i).Width * dProportionateWidth, _
            tCtlProp(i).Height * dProportionateHeight
        End If
    Next i
Exit Sub
errResize:
'    If DEBUGMODE = True Then
'        Debug.Print "Error:" & Err.Description
'    End If
    Resume Next
End Sub

Private Sub StoreOriginalSizes(ByRef frm As Form)
    Dim i           As Integer
    '------------------------------------
    On Error GoTo errStoreOriginalSizes
    m_iControlsCount = frm.Controls.Count
    ReDim tCtlProp(0 To m_iControlsCount - 1)
    For i = 0 To m_iControlsCount - 1
        tCtlProp(i).Left = frm.Controls(i).Left
        tCtlProp(i).Top = frm.Controls(i).Top
        tCtlProp(i).Width = frm.Controls(i).Width
        tCtlProp(i).Height = frm.Controls(i).Height
        tCtlProp(i).FntSize = frm.Controls(i).Font.Size
    Next i
    m_lFormHeight = frm.ScaleHeight
    m_lFormWidth = frm.ScaleWidth
    m_bInitDone = True
Exit Sub
errStoreOriginalSizes:
'    If DEBUGMODE = True Then
'        Debug.Print "Error:" & Err.Description
'    End If
    Resume Next
End Sub

